/* 

                          Firewall Builder

                 Copyright (C) 2004 NetCitadel, LLC

  Author:  Vadim Kurland     vadim@fwbuilder.org

  $Id: procurveaclAdvancedDialog.h 2884 2010-05-11 02:59:53Z vadim $

  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#ifndef __PROCURVEACLADVANCEDDIALOG_H_
#define __PROCURVEACLADVANCEDDIALOG_H_

#include <ui_procurveacladvanceddialog_q.h>
#include "DialogData.h"
#include <QDialog>

#include <string>

class QWidget;
class QSpinBox;
class QComboBox;
class QCheckBox;
class QProcess;

namespace libfwbuilder {
    class FWObject;
};

class procurveaclAdvancedDialog : public QDialog
{
    Q_OBJECT

    libfwbuilder::FWObject          *obj;
    DialogData                       data;
    Ui::procurveaclAdvancedDialog_q      *m_dialog;
    
 public:
    procurveaclAdvancedDialog(QWidget *parent,libfwbuilder::FWObject *o);
    ~procurveaclAdvancedDialog();

protected slots:

    virtual void accept();
    virtual void reject();

    virtual void editProlog();
    virtual void editEpilog();

    virtual void scriptACLModeChanged();
    virtual void toggleGenerateLogging();
};

#endif // __PROCURVEACLADVANCEDDIALOG_H

